#include <iostream>
#include <vector>
#include <algorithm>

using std::vector;
using std::cout;

#include "TAGSNP.h"

void Preprocess(bool **cover_table, BinMat &data, uint16_t &uni_hap_num, uint16_t SNP_NUM)
{
    uint16_t pairs_num = 0;
    BinMat unique_hap;
    vector< vector<uint16_t> > cover;

    register uint16_t x = 0, y = 0, z = 0;
    uint16_t count;

    sort(data.begin(),data.end());

    unique_hap.push_back(data[0]);
    for (x=0; x<HAP_NUM-1; x++)
    {
        if ( (data[x] != data[x+1]) )
            unique_hap.push_back(data[x+1]);
    }

    uni_hap_num = unique_hap.size();

    pairs_num = uni_hap_num*(uni_hap_num-1)/2;

    cover.assign(pairs_num, vector<uint16_t>( 1 + SNP_NUM , 0 ) );

    for (z = 0; z<SNP_NUM; z++)
    {
        count = 0;
        for (x=0; x<uni_hap_num-1; x++)
            for (y=x+1; y<uni_hap_num; y++)
            {
                cover[count][z+1] = ( unique_hap[x][z] != unique_hap[y][z] );
                cover[count][0] += cover[count][z+1];
                count++;
            }
    }

    sort(cover.begin(),cover.end());

    for (x=0; x<SNP_NUM; x++)
    {
        cover_table[x] = new bool [ pairs_num ];
        for (y=0; y<pairs_num; y++)
        {
            cover_table[x][y] = cover[y][x+1];
        }
    }

//    cover_mtx.assign(SNP_NUM, vector<bool>( (unique_hap.size()-1)*unique_hap.size()/2) );
/*    for (uint16_t k=0;k<SNP_NUM;k++)
    {
        cover_table[k] = new bool [ uni_hap_num*(uni_hap_num-1)/2 ];
        uint16_t count(0);
        for (uint16_t i=0;i<uni_hap_num-1;i++)
            for (uint16_t j=i+1;j<uni_hap_num;j++)
            {
                cover_table[k][count] = ( unique_hap[i][k] != unique_hap[j][k] );
                count++;
            }
    }*/
}
