#ifndef TAGSNP_H_INCLUDED
#define TAGSNP_H_INCLUDED

#include <vector>
#include <MOO-EALib/PopulationMOO.h>

using std::vector;

typedef vector< vector<bool> > BinMat;

const uint16_t HAP_NUM = 48;
const double eps = pow(2.0, -100.0);
const double inf = pow(2.0, 1000.0);

void Preprocess (   bool **,
                    BinMat &,
                    uint16_t &,
                    uint16_t );

void NSGAII (   bool **,
                const BinMat &,
                const vector< vector<double> > &,
                const uint16_t,
                const uint16_t,
                const uint16_t,
                /*const uint16_t,
                const uint16_t,*/
                const double  );

void calcMOFitness  (   IndividualMOO &,
                        bool **,
                        const BinMat &,
                        const uint16_t,
                        const uint16_t,
                        vector<double> & );

#endif // TAGSNP_H_INCLUDED
