#include <iostream>
#include <fstream>
#include <vector>
#include <ctime>

#include <MOO-EALib/PopulationMOO.h>

using std::vector;
using std::string;
using std::cout;

#include "TAGSNP.h"

static void ReadWeight(vector< vector<double> > &);

int main(int argc, char *argv[])
{
    uint16_t SNP_NUM = 0;
    uint16_t uni_hap_num = 0;
    uint16_t BlockNo = 1;

    BinMat data;
    vector< string > rawdata;
    vector< uint16_t > snp_useful;

    vector< vector<double> >    TargetVector;

    clock_t t1,t2;

    string str;
    std::ifstream input ("input.txt", std::ios::in);

//    system("del All.csv");

    cout << "eps = " << eps << "\n";
    cout << "INF = " << inf << "\n";

    ReadWeight(TargetVector);

    while (!input.eof())
    {
        register uint16_t i, j;
        for ( i=HAP_NUM; i--; )
        {
            getline(input,str);
            rawdata.push_back(str);
        }

        uint16_t sum;
        for (i=0; i<str.length(); i++)
        {
            sum = 0;
            for (j=0; j<HAP_NUM; j++)
            {
                rawdata[j][i] -= 48;
                sum += rawdata[j][i];
            }

            if ( sum > 0 && sum < HAP_NUM )
                snp_useful.push_back(i);
        }

        SNP_NUM = snp_useful.size();
        data.assign(HAP_NUM, vector<bool>( SNP_NUM ));
        bool **cover_table = new bool *[ SNP_NUM ];

        for (j=0; j<HAP_NUM; j++)
            for (i=0; i<SNP_NUM; i++)
                data[j][i] = rawdata[j][ snp_useful[i] ];

/*
        getline(input,str);
        SNP_NUM = str.length();

        data.assign(HAP_NUM, vector<bool>( SNP_NUM ));
        bool **cover_table = new bool *[ SNP_NUM ];

        for (uint16_t i=0;i<SNP_NUM;i++)    data[0][i] = str[i] - 48;
        for (uint16_t h=1;h<HAP_NUM;h++)
        {
            getline(input,str);
            for (uint16_t i=0;i<SNP_NUM;i++)    data[h][i] = str[i] - 48;
        }
*/

        Preprocess(cover_table, data, uni_hap_num, SNP_NUM);

        t1 = clock();

        NSGAII(cover_table, data, TargetVector, uni_hap_num, SNP_NUM, BlockNo, atof(argv[1])/*, atoi(argv[2]), atof(argv[3])*/);

        t2 = clock();

        cout << BlockNo << "\t" << SNP_NUM << "\t" << double(t2-t1)/CLOCKS_PER_SEC << "\n";

        BlockNo++;
        data.clear(); rawdata.clear(); snp_useful.clear();
        for ( i=SNP_NUM; i--; )
            delete [] cover_table[i];
        delete [] cover_table;
    }
    input.close();

    return 0;
}

static void ReadWeight(vector< vector<double> > &w)
{
    vector<double> Tv (4, .0);
    std::ifstream w_input ("weight.dat", std::ios::in);

    while( !w_input.eof() )
    {
        w_input >> Tv[3] >> Tv[2] >> Tv[1] >> Tv[0];
        w.push_back(Tv);
    }
    cout << "w_vector size = " << w.size() << "\n";

    w_input.close();
}
