#include <SharkDefs.h>
#include <algorithm>
#include <vector>

#include <MOO-EALib/IndividualMOO.h>
#include <MOO-EALib/PopulationMOO.h>
#include <MOO-EALib/SelectionMOO.h>

#include "TAGSNP.h"

void XD(PopulationMOO & pop)
{
    pop.NSGAIIRank();

	uint16_t m_maxMOORank = pop.maxMOORank();

	uint16_t i, j, k;

	bool m_bUnpenalizedFitness = false;

	for (i = 1; i <= m_maxMOORank; i++)
	{
		std::vector<uint16_t> p(0);

		for (j = 0; j < pop.size(); j++)
		{
			if (pop[j].getMOORank() == i)
			{
				p.push_back(j);
			}
		}

		std::vector<double> distance(pop.size(), 0);

		ObjectiveSort objSort(m_bUnpenalizedFitness, 0);
		objSort.pop = &pop;

		double factor;

		for (j = 0; j < 4; j++)
		{
			objSort.m_objective = j;
			std::sort(p.begin(), p.end(), objSort);

			distance[p.front()] = distance[p.back()] = std::numeric_limits<double>::max();
			factor = pop[p.back()].getMOOFitnessValues(m_bUnpenalizedFitness)[j] - pop[p.front()].getMOOFitnessValues(m_bUnpenalizedFitness)[j];
			factor = Shark::max(1.0, static_cast<double>(factor));	// required for Macintosh compiler
			for (k = 1; k < p.size() - 1; k++)
			{
				std::vector<double> & a = pop[p[k+1]].getMOOFitnessValues(m_bUnpenalizedFitness);
				std::vector<double> & b = pop[p[k-1]].getMOOFitnessValues(m_bUnpenalizedFitness);

				distance[p[k]] += (a[j] - b[j]) / factor;
			}
		}


		for (j = 0; j < p.size(); j++)
		{
			pop[p[j]].setMOOShare(distance[p[j]]);
		}
	}
}
